//var scrollpos = 0;
prism.registerControlSubGrandTotal = function (widget) {
    var varNameGTSpecItemsToHide = "specRowGrandTotalToHide",
        varNameSTSpecItemsToHide = "subtotalFieldsToHide",
        allSTItems = "allSTItems",
        allGTItems = "allGTItems",
        menuTypes = { GT:"grandTotals_rows", ST:'subtotals'};

    widget.on("initialized", function (e, args) {

        var unregister = prism.on("beforemenu", function (e, args) {
            var widget = e.currentScope.widget;

            // only if we on panel item menu and widget type is pivot
            if (widget.type !== 'pivot' ||
                args.settings.name !== "widget-metadataitem" ||
                args.settings.item.$$panel.name !== "rows"){
                return;
            }

            // Init custom grand total parameter on widget
            if (!defined(widget.style.allGTItems)){
                setCustomShowAllItemGT(getDefGrandTotalShowFromWidget() || false);
            }

            // Init custom sub total  parameter on panel item
            if (!defined(getCustomShowAllItemST(args.settings.item))){
                setCustomShowAllItemST(args.settings.item,false);
            }

            // init grand total sub menu
            if (isItemEnableInMenu(args.settings.items, menuTypes.GT)) {
                initSubMenu(args.settings,
                    menuTypes.GT,
                    executeSpecificItemGrandTotalFunc,
                    executeAllGrandTotalMenuItem,
                    getCustomShowAllItemGT()
                )
            }

            // init subtotal
            if (isItemEnableInMenu(args.settings.items, menuTypes.ST)) {
                initSubMenu(args.settings,
                    menuTypes.ST,
                    executeSpecificSTItemFunc,
                    executeAllSubTotalMenuItem,
                    getCustomShowAllItemST(args.settings.item) || false
                )
            }
        });

        widget.on("destroyed", function () {
            unregister();
        });

        widget.on("processresult",function(w,args){
            //remove deleted values
            var htmlTable = $(args.result.table);
            var arrGTHideItems = removeDeletedValuesFromProperty(w,"style." + varNameGTSpecItemsToHide);

            var startValuesIndexInHtmlTable = getNumberOfEnabledItems(w.metadata.panel("rows").items) + getNumberOfEnabledItems(w.metadata.panel("columns").items);

            // Handle grand total
            if ((!defined(arrGTHideItems) || arrGTHideItems.length === 0) &&
                getDefGrandTotalShowFromWidget()){
                setCustomShowAllItemGT(true);
            }

            htmlTable = deleteGrandTotalFromTable(htmlTable,startValuesIndexInHtmlTable);

            var rowItemIndex = -1;

            // Handle sub total
            _.each(w.metadata.panel('rows').items,function(item){
                var isItemDisabled = $$get(item, 'disabled') || false;

                if (!isItemDisabled) {
                    rowItemIndex++;
                    var arrSBHideItems = removeDeletedValuesFromProperty(item, varNameSTSpecItemsToHide);

                    if ((!defined(arrSBHideItems) || arrSBHideItems.length === 0) &&
                        getDefSubtotalFromItem(item)) {
                        setCustomShowAllItemST(item, true);
                    }

                    if (getDefSubtotalFromItem(item)){
                        htmlTable = deleteSTFromHTML(item,startValuesIndexInHtmlTable,htmlTable,rowItemIndex,w.metadata.panel('values').items);
                    }
                }
            });

            args.result.table = htmlTable[0].outerHTML;;
        });

        function initSubMenu(settings, menuType,executeSpecificItemFunc,executeAllMenuItemFunc,isAllMenuItemChecked){
            var menuItem = getItemFromMenu(settings.items, menuType);

            menuItem.items = getAllValuesFromValuePanelToAddToMenu(
                executeSpecificItemFunc,
                executeAllMenuItemFunc,
                isAllMenuItemChecked,
                settings.item,
                menuType);
        }

        function executeAllSubTotalMenuItem(){
            var currentValue = getCustomShowAllItemST(this.rowsItem) || false;
            setCustomShowAllItemST(this.rowsItem,!currentValue);
            setDefSubtotalFromItem(this.rowsItem,!currentValue);
            setSTItemsToHideForItem(this.rowsItem, undefined);
            widget.refresh();
        }

        function executeAllGrandTotalMenuItem(){
            widget.style.allGTItems =  !widget.style.allGTItems;
            widget.style.rowsGrandTotal = widget.style.allGTItems;
            $$set(widget.style, varNameGTSpecItemsToHide, undefined);
            widget.refresh();
        }

        function isItemInArrayByJaql(items,item){
            return defined(_.find(items,function(i){
                return compareItemsUsingJaql(i,item);
            },item));
        }

        function deleteSTFromHTML(rowItem,startValuesIndex ,htmlTable, currItemIndex, valuesPanelItems){
            if (!getDefSubtotalFromItem(rowItem)){
                return htmlTable;
            }

            var itemsToHide = getSTItemsToHideForItem(rowItem);

            if (!itemsToHide || itemsToHide.length === 0){
                return htmlTable;
            }

            var arrIndexForItemsToHideFromST = [];
            var currIndex = startValuesIndex;

            _.each(valuesPanelItems, function(item){
                if (!checkIfItemDisabled(item)){
                    if (isItemInArrayByJaql(itemsToHide,item)){
                        arrIndexForItemsToHideFromST.push(currIndex);
                    }
                    currIndex++;
                }
            });

            var allSTRow = htmlTable.find('td:contains("Total")[fidx=' + currItemIndex +']').parent();

            _.each(arrIndexForItemsToHideFromST,function(elementIndex){
                $(allSTRow).find('td[fidx=' + elementIndex + ']').text("");
            });

            return htmlTable;
        }

        function deleteGrandTotalFromTable(htmlTable,startValuesIndexInHtml){

            if (!getDefGrandTotalShowFromWidget()){
                return htmlTable;
            }

            var itemsToHide = getGTItemsToHideFromWidget();

            if (!itemsToHide || itemsToHide.length === 0){
                return  htmlTable;
            }

            var arrIndexForItemsToHideFromGT = [];

            _.each(widget.metadata.panel("values").items, function(item){
                if (!checkIfItemDisabled(item)){
                    if (isItemInArrayByJaql(itemsToHide,item)){
                        arrIndexForItemsToHideFromGT.push(startValuesIndexInHtml);
                    }
                    startValuesIndexInHtml++;
                }
            });

            var allGrandTotalRow = htmlTable.find('tr:contains("Total")').last();

            _.each(arrIndexForItemsToHideFromGT,function(elementIndex){
                $(allGrandTotalRow).find('td[fidx=' + elementIndex + ']').text("");
            });

            // convert to string
            return htmlTable;
        }

        function checkIfItemDisabled(item){
            return (defined(item.disabled) && item.disabled);
        }

        function getNumberOfEnabledItems(items){
            var number = 0;

            _.each(items,function(item){
                // check if the item is enabled
                if (!checkIfItemDisabled(item)){
                    number++;
                }
            });

            return number;
        }

        function setCustomShowAllItemGT(value){
            $$set(widget, 'style.' + allGTItems,value);
        }

        function getCustomShowAllItemGT(){
            return $$get(widget, 'style.' + allGTItems);
        }

        function setSTItemsToHideForItem(item, value){
            $$set(item, varNameSTSpecItemsToHide,value);
        }

        function getSTItemsToHideForItem(item) {
            return  $$get(item, varNameSTSpecItemsToHide);
        }

        function setGTItemsToHideFromWidget(specificGrandTotal) {
            $$set(widget.style, varNameGTSpecItemsToHide,specificGrandTotal);
        }

        function getGTItemsToHideFromWidget() {
            return $$get(widget.style, varNameGTSpecItemsToHide) || [];
        }

        function getCustomShowAllItemST(item) {
            return  $$get(item, allSTItems);
        }

        function setCustomShowAllItemST(item,value) {
              $$set(item, allSTItems, value);
        }

        function getDefSubtotalFromItem(item){
            return $$get(item, 'format.subtotal') || false;
        }

        function setDefSubtotalFromItem(item, value){
            $$set(item, 'format.subtotal', value);
        }

        function getDefGrandTotalShowFromWidget(){
            return widget.style.rowsGrandTotal || false;
        }

        function removeDeletedValuesFromProperty(obj, propName){
            var arrayToDeleteFrom = $$get(obj,propName);

            if (arrayToDeleteFrom && arrayToDeleteFrom.length > 0) {
                arrayToDeleteFrom = _.reject(arrayToDeleteFrom, function(item){
                    return !defined(_.find(widget.metadata.panel("values").items,function(panelItem){
                        return compareItemsUsingJaql(panelItem,this);
                    },item));
                });
            }

            $$set(obj,propName,arrayToDeleteFrom);

           return arrayToDeleteFrom;
        }

        function isItemEnableInMenu(items, mid) {
            var item = _.find(items, function (i) {
                return i.mid === mid;
            });

            return defined(item) && !defined(item.disabled);
        }

        function getItemFromMenu(items, mid) {
            return _.find(items, function (i) {
                return i.mid === mid;
            });
        }

        function compareItemsUsingJaql(item1,item2){
            return item1.jaql.dim === item2.jaql.dim &&
                item1.jaql.formula === item2.jaql.formula &&
                item1.jaql.agg === item2.jaql.agg;
        }


        function isItemChecked(itemToCheck, stItem, menuType){
           var itemsToHide;

            // we in sub total item
            if (menuType === menuTypes.ST){
                // All items include in the grand total
                if (!getDefSubtotalFromItem(stItem)){
                    return false;
                }else if (getCustomShowAllItemST(stItem)){
                    return true;
                }

                // check if current item is hidden
                itemsToHide = getSTItemsToHideForItem(stItem);
            }
            // we in grand total item
            else{

                if (!getDefGrandTotalShowFromWidget()){
                    return false;
                }else if (getCustomShowAllItemGT()){
                    return true;
                }

                itemsToHide = getGTItemsToHideFromWidget();
            }

            var getCheckedItem = _.find(itemsToHide,function(currItem,i){
                return compareItemsUsingJaql(currItem, itemToCheck);
            });

            return !defined(getCheckedItem);
        }

        function executeSpecificItemGrandTotalFunc(){
            var specificGrandTotal =  getGTItemsToHideFromWidget() || [];

            // user want to hide the value
            if (this.checked){
                setCustomShowAllItemGT(false);

                // check if there are values to show
                if (specificGrandTotal.length + 1 ===
                    widget.metadata.panel("values").items.length){
                    widget.style.rowsGrandTotal = false;
                    specificGrandTotal = undefined;
                } else {

                    //Add the item to items array to hide
                    specificGrandTotal.push({
                        jaql: this.item.jaql
                    });
                }
            }
            // user want to show a value
            else{
                // user want to show the value
                widget.style.rowsGrandTotal = true;

                if (specificGrandTotal.length === 0){
                    // insert the rest of the values to the array
                    _.each(widget.metadata.panel("values").items,function(item) {
                        if (!compareItemsUsingJaql(this.item,item)) {
                            specificGrandTotal.push({
                                jaql: item.jaql
                            });
                        }
                    },this);

                }else {
                    // remove from array to hide
                    specificGrandTotal =  _.reject(specificGrandTotal, function(item){
                        return compareItemsUsingJaql(item, this.item);
                    },this);
                }

                if (!specificGrandTotal || specificGrandTotal.length === 0){
                    setCustomShowAllItemGT(true);
                }
            }

            setGTItemsToHideFromWidget(specificGrandTotal);

            widget.refresh();
        }

        function executeSpecificSTItemFunc(){
            var specificSTItemsToHide = getSTItemsToHideForItem(this.rowsItem) || [];

            // user want to hide the value
            if (this.checked){
                setCustomShowAllItemST(this.rowsItem,false);

                // check if there are values to show
                if (specificSTItemsToHide.length + 1 ===
                    widget.metadata.panel("values").items.length){

                    setDefSubtotalFromItem(this.rowsItem,false);
                    specificSTItemsToHide = undefined;
                } else {

                    //Add the item to items array to hide
                    specificSTItemsToHide.push({
                        jaql: this.item.jaql
                    });
                }
            }
            // user want to show a value
            else{
                // user want to show the value
                setDefSubtotalFromItem(this.rowsItem,true);

                if (specificSTItemsToHide.length === 0){

                    // insert the rest of the values to the array
                    _.each(widget.metadata.panel("values").items,function(item) {
                        if (!compareItemsUsingJaql(this.item,item)) {
                            specificSTItemsToHide.push({
                                jaql: item.jaql
                            });
                        }
                    },this);

                }else {
                    // remove from array to hide
                    specificSTItemsToHide =  _.reject(specificSTItemsToHide, function(item){
                        return compareItemsUsingJaql(item, this.item);
                    },this);
                }

                if (!specificSTItemsToHide || specificSTItemsToHide.length === 0){
                    setCustomShowAllItemST(this.rowsItem,true);
                }
            }

            setSTItemsToHideForItem(this.rowsItem,specificSTItemsToHide);
            widget.refresh();
        }

        function getAllValuesFromValuePanelToAddToMenu(executeSpecificItemFunc,allItemExecuteFunc, allItemChecked,rowsItem, type){
            var itemsToMenu = [];

            _.each(widget.metadata.panel('values').items,function(item,index){
                itemsToMenu.push({
                    caption: item.jaql.title,
                    type: "check",
                    execute: executeSpecificItemFunc,
                    checked: isItemChecked(item,rowsItem,type),
                    oid: index,
                    item: item,
                    rowsItem: rowsItem
                });
            });

            itemsToMenu.push({ type: "separator" });

            itemsToMenu.push({
                caption: "All",
                type: "check",
                execute: allItemExecuteFunc,
                checked: allItemChecked,
                oid: widget.metadata.panel('values').items.length,
                rowsItem:rowsItem
            });

            return itemsToMenu;
        }
    });
};